From d67e97726023568c9251b6f36b00572739bf46c7 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 11:27:42 +0100
Subject: [PATCH 03/54] feat: sidebar layout

---
 lact-gui/src/app/mod.rs                     | 108 ++++++++++++++++----
 lact-gui/src/app/{header.rs => toolbars.rs} |  49 ++++-----
 2 files changed, 113 insertions(+), 44 deletions(-)
 rename lact-gui/src/app/{header.rs => toolbars.rs} (59%)

diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index d82b1de1..244c697e 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -1,8 +1,8 @@
 mod apply_revealer;
-mod header;
 mod info_row;
 mod page_section;
 mod root_stack;
+mod toolbars;
 
 use crate::{APP_ID, GUI_VERSION};
 use anyhow::{anyhow, Context};
@@ -10,17 +10,17 @@ use apply_revealer::ApplyRevealer;
 use glib::clone;
 use gtk::glib::{timeout_future, ControlFlow};
 use gtk::{gio::ApplicationFlags, prelude::*, *};
-use header::Header;
 use lact_client::schema::request::{ConfirmCommand, SetClocksCommand};
 use lact_client::schema::DeviceStats;
 use lact_client::DaemonClient;
 use lact_daemon::MODULE_CONF_PATH;
-use libadwaita::prelude::MessageDialogExt;
+use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt};
 use root_stack::RootStack;
 use std::cell::RefCell;
 use std::rc::Rc;
 use std::sync::atomic::AtomicBool;
 use std::time::Duration;
+use toolbars::Toolbars;
 use tracing::{debug, error, trace, warn};
 
 // In ms
@@ -28,9 +28,9 @@ const STATS_POLL_INTERVAL: u64 = 250;
 
 #[derive(Clone)]
 pub struct App {
-    application: Application,
-    pub window: ApplicationWindow,
-    pub header: Header,
+    application: libadwaita::Application,
+    pub window: libadwaita::ApplicationWindow,
+    pub toolbars: Toolbars,
     root_stack: RootStack,
     apply_revealer: ApplyRevealer,
     daemon_client: DaemonClient,
@@ -38,18 +38,16 @@ pub struct App {
 
 impl App {
     pub fn new(daemon_client: DaemonClient) -> Self {
-        let application = Application::new(Some(APP_ID), ApplicationFlags::default());
+        let application = libadwaita::Application::new(Some(APP_ID), ApplicationFlags::default());
 
-        let header = Header::new();
-        let window = ApplicationWindow::builder()
+        let toolbars = Toolbars::new();
+        let window = libadwaita::ApplicationWindow::builder()
             .title("LACT")
             .default_width(600)
             .default_height(820)
             .icon_name(APP_ID)
             .build();
 
-        window.set_titlebar(Some(&header.container));
-
         let system_info_buf = daemon_client
             .get_system_info()
             .expect("Could not fetch system info");
@@ -62,22 +60,89 @@ impl App {
 
         let root_stack = RootStack::new(system_info, daemon_client.embedded);
 
-        header.set_switcher_stack(&root_stack.container);
+        {
+            let stack = root_stack.container.clone();
+            let title = toolbars.title.clone();
+            root_stack.container.connect_visible_child_notify(move |_| {
+                if let Some(child) = stack.visible_child() {
+                    title.set_title(stack.page(&child).title().unwrap().as_str())
+                }
+            });
+        }
 
-        let root_box = Box::new(Orientation::Vertical, 5);
+        let root_view = libadwaita::ToolbarView::new();
 
-        root_box.append(&root_stack.container);
+        root_view.add_top_bar(&toolbars.headerbar);
+        root_view.set_content(Some(&root_stack.container));
 
         let apply_revealer = ApplyRevealer::new();
 
-        root_box.append(&apply_revealer.container);
+        root_view.add_bottom_bar(&apply_revealer.container);
+
+        let sidebar_view = libadwaita::ToolbarView::new();
+
+        let stack_sidebar = StackSidebar::builder()
+            .stack(&root_stack.container)
+            .vexpand(true)
+            .build();
+        stack_sidebar.remove_css_class("sidebar");
+        sidebar_view.add_top_bar(
+            &libadwaita::HeaderBar::builder()
+                .title_widget(&libadwaita::WindowTitle::builder().title("LACT").build())
+                .build(),
+        );
+        sidebar_view.set_content(Some(
+            &ScrolledWindow::builder()
+                .child(&stack_sidebar)
+                .vexpand(true)
+                .hscrollbar_policy(PolicyType::Never)
+                .build(),
+        ));
+        sidebar_view.add_bottom_bar(&toolbars.gpu_selector);
+
+        let split_view = libadwaita::NavigationSplitView::builder()
+            .sidebar(
+                &libadwaita::NavigationPage::builder()
+                    .child(&sidebar_view)
+                    .build(),
+            )
+            .content(
+                &libadwaita::NavigationPage::builder()
+                    .child(&root_view)
+                    .build(),
+            )
+            .build();
+
+        {
+            let split_view = split_view.clone();
+            let lb = stack_sidebar
+                .first_child()
+                .unwrap()
+                .first_child()
+                .unwrap()
+                .first_child()
+                .unwrap()
+                .downcast::<ListBox>()
+                .unwrap();
+            lb.connect_row_activated(move |_lb, _row| {
+                split_view.set_show_content(true);
+            });
+        }
+
+        let breakpoint = libadwaita::Breakpoint::new(libadwaita::BreakpointCondition::new_length(
+            libadwaita::BreakpointConditionLengthType::MaxWidth,
+            800.0,
+            libadwaita::LengthUnit::Sp,
+        ));
+        breakpoint.add_setter(&split_view, "collapsed", &glib::Value::from(true));
+        window.add_breakpoint(breakpoint);
 
-        window.set_child(Some(&root_box));
+        window.set_content(Some(&split_view));
 
         App {
             application,
             window,
-            header,
+            toolbars,
             root_stack,
             apply_revealer,
             daemon_client,
@@ -91,7 +156,7 @@ impl App {
 
                 let current_gpu_id = Rc::new(RefCell::new(String::new()));
 
-                app.header.connect_gpu_selection_changed(clone!(@strong app, @strong current_gpu_id => move |gpu_id| {
+                app.toolbars.connect_gpu_selection_changed(clone!(@strong app, @strong current_gpu_id => move |gpu_id| {
                     debug!("GPU Selection changed");
                     app.set_info(&gpu_id);
                     *current_gpu_id.borrow_mut() = gpu_id;
@@ -103,7 +168,7 @@ impl App {
                     .list_devices()
                     .expect("Could not list devices");
                 let devices = devices_buf.inner().expect("Could not access devices");
-                app.header.set_devices(&devices);
+                app.toolbars.set_devices(&devices);
 
                 app.root_stack.oc_page.clocks_frame.connect_clocks_reset(clone!(@strong app, @strong current_gpu_id => move || {
                     debug!("Resetting clocks");
@@ -474,6 +539,7 @@ impl App {
 
     fn enable_overclocking(&self) {
         let text = format!("This will enable the overdrive feature of the amdgpu driver by creating a file at <b>{MODULE_CONF_PATH}</b>. Are you sure you want to do this?");
+        // TODO: to libadwaita
         let dialog = MessageDialog::builder()
             .title("Enable Overclocking")
             .use_markup(true)
@@ -508,6 +574,7 @@ impl App {
 
     fn ask_confirmation(&self, gpu_id: String, mut delay: u64) {
         let text = confirmation_text(delay);
+        // TODO: to libadwaita
         let dialog = MessageDialog::builder()
             .title("Confirm settings")
             .text(text)
@@ -562,9 +629,10 @@ enum GuiUpdateMsg {
     GpuStats(DeviceStats),
 }
 
-fn show_error(parent: &ApplicationWindow, err: anyhow::Error) {
+fn show_error(parent: &libadwaita::ApplicationWindow, err: anyhow::Error) {
     let text = format!("{err:?}");
     warn!("{}", text.trim());
+    // TODO: to libadwaita
     let diag = MessageDialog::builder()
         .title("Error")
         .message_type(MessageType::Error)
diff --git a/lact-gui/src/app/header.rs b/lact-gui/src/app/toolbars.rs
similarity index 59%
rename from lact-gui/src/app/header.rs
rename to lact-gui/src/app/toolbars.rs
index abd9e133..22f9d1dc 100644
--- a/lact-gui/src/app/header.rs
+++ b/lact-gui/src/app/toolbars.rs
@@ -4,37 +4,38 @@ use lact_client::schema::DeviceListEntry;
 use pango::EllipsizeMode;
 
 #[derive(Clone)]
-pub struct Header {
-    pub container: HeaderBar,
-    gpu_selector: ComboBoxText,
-    switcher: StackSwitcher,
+pub struct Toolbars {
+    pub headerbar: libadwaita::HeaderBar,
+    pub gpu_selector: ComboBoxText,
+    pub title: libadwaita::WindowTitle,
 }
 
-impl Header {
+impl Toolbars {
     pub fn new() -> Self {
-        let container = HeaderBar::new();
-
-        container.set_title_widget(Some(&Box::default())); // Workaround to hide the title
-
-        container.set_show_title_buttons(true);
-
-        let gpu_selector = ComboBoxText::new();
-        container.pack_start(&gpu_selector);
-
-        let switcher = StackSwitcher::new();
-        container.pack_start(&switcher);
-
-        Header {
-            container,
+        let title = libadwaita::WindowTitle::builder()
+            .title("Information")
+            .build();
+
+        let headerbar = libadwaita::HeaderBar::builder()
+            .title_widget(&title)
+            .show_title(true)
+            .build();
+
+        // TODO: new gtk select
+        let gpu_selector = ComboBoxText::builder()
+            .margin_top(12)
+            .margin_bottom(12)
+            .margin_start(12)
+            .margin_end(12)
+            .build();
+
+        Self {
+            headerbar,
             gpu_selector,
-            switcher,
+            title,
         }
     }
 
-    pub fn set_switcher_stack(&self, stack: &Stack) {
-        self.switcher.set_stack(Some(stack));
-    }
-
     pub fn set_devices(&self, gpus: &[DeviceListEntry<'_>]) {
         for (i, entry) in gpus.iter().enumerate() {
             let name = format!("{i}: {}", entry.name.unwrap_or_default());

